package fr.username404.snowygui.forge

import fr.username404.snowygui.Snowy
import fr.username404.snowygui.config.SnowyConfigScreen
import fr.username404.snowygui.config.configScreenParent
import fr.username404.snowygui.gui.feature.ButtonImpl
import net.minecraftforge.fml.ExtensionPoint
import net.minecraftforge.fml.ModList
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent
import net.minecraftforge.forgespi.language.ModFileScanData
import org.objectweb.asm.Type
import thedarkcolour.kotlinforforge.forge.FORGE_BUS
import thedarkcolour.kotlinforforge.forge.LOADING_CONTEXT
import thedarkcolour.kotlinforforge.forge.MOD_BUS
import java.util.function.BiFunction

@Mod("snowygui")
@Suppress("UNUSED_PARAMETER")
class ForgeInit: Snowy() {
    private fun initSetup(event: FMLClientSetupEvent) = atInit()
    private fun configSetup(event: FMLClientSetupEvent) {
        LOADING_CONTEXT.registerExtensionPoint(
            ExtensionPoint.CONFIGGUIFACTORY
        ) { BiFunction { _, parent -> configScreenParent = parent; SnowyConfigScreen } }
    }
    override val annotatedButtons = ModList.get() // Forge-specific reflection
        .allScanData
        .flatMap { obj: ModFileScanData -> obj.classes }
        .filter { data: ModFileScanData.ClassData? ->
            (data!!.javaClass.getDeclaredField("clazz").apply { isAccessible = true }.get(data) as Type).className.let { classname ->
                classname.startsWith(FeaturePackage) && Class.forName(classname).isValidForButtonCollection()
            }
        }
        .map { Class.forName((it!!.javaClass.getDeclaredField("clazz").apply { isAccessible = true }.get(it) as Type).className).asSubclass(ButtonImpl::class.java)}
        .toSet()
    init {
        with(MOD_BUS) {
            addListener(this@ForgeInit::initSetup)
            addListener(this@ForgeInit::configSetup)
        }
        with(FORGE_BUS) {
            register(HudHandler)
            register(ZoomHandler)
        }
    }
}